package com.github.clevernucleus.playerex.api.client.event;

import net.fabricmc.api.EnvType;
import net.fabricmc.api.Environment;
import net.fabricmc.fabric.api.event.Event;
import net.fabricmc.fabric.api.event.EventFactory;
import net.minecraft.class_1007;
import net.minecraft.class_4587;
import net.minecraft.class_4597;
import net.minecraft.class_742;
import net.minecraft.class_898;

/**
 * Offers a hook into the method {@link class_1007#renderLabelIfPresent(AbstractClientPlayerEntity, Text, MatrixStack, VertexConsumerProvider, int)}.
 * Allows for rendering things ingame.
 * 
 * @author CleverNucleus
 *
 */
@Environment(EnvType.CLIENT)
public final class NameplateRenderEvent {
	
	/**
	 * Called when rendering the player's nameplate (on multiplayer; on the client).
	 */
	public static final Event<NameplateRenderEvent.Render> EVENT = EventFactory.createArrayBacked(NameplateRenderEvent.Render.class, listeners -> (dispatcher, renderer, player, matrixStack, vertexConsumerProvider, light) -> {
		for(NameplateRenderEvent.Render listener : listeners) {
			listener.render(dispatcher, renderer, player, matrixStack, vertexConsumerProvider, light);
		}
	});
	
	@FunctionalInterface
	public interface Render {
		
		/**
		 * 
		 * @param dispatcher
		 * @param renderer
		 * @param player
		 * @param matrixStack
		 * @param vertexConsumerProvider
		 * @param light
		 */
		void render(final class_898 dispatcher, final class_1007 renderer, final class_742 player, final class_4587 matrixStack, final class_4597 vertexConsumerProvider, final int light);
	}
}
